-- Uses routines from following libraries:
--   Pipe library version 1.0 by Jeffrey Fielding (JJProg@cyberbury.net)
--   Linux File I/O Library version 1.0 by Jeffrey Fielding (JJProg@cyberbury.net)

atom STDLIB , POPEN, PCLOSE, FGETC, uname, ptr

if platform() = LINUX then
  STDLIB = open_dll("")
  POPEN  = define_c_func(STDLIB, "popen",  {C_POINTER, C_POINTER}, C_POINTER)
  PCLOSE = define_c_func(STDLIB, "pclose", {C_POINTER}, C_INT)
  FGETC  = define_c_func(STDLIB, "fgetc",  {C_POINTER}, C_INT)
  uname  = define_c_func(STDLIB, "uname",  {C_POINTER}, C_UINT)
end if

------------------------------------------------------------------------------

function popen(sequence command, sequence mode)
  atom cmd, mod, r

  if platform() = LINUX then
    cmd = allocate_string(command)
    mod = allocate_string(mode)
    r = c_func(POPEN,{cmd,mod})
    if r = 0 then r = -1 end if
    free(cmd)
    free(mod)
    return r
  else
    return 0
  end if
end function

------------------------------------------------------------------------------

procedure pclose(atom pipe)
  integer ret

  if platform() = LINUX then
    ret = c_func(PCLOSE,{pipe})
  end if
end procedure

------------------------------------------------------------------------------

function fgetc(atom fl)
  if platform() = LINUX then
    return c_func(FGETC,{fl})
  else
    return 0
  end if
end function

------------------------------------------------------------------------------

function execute_command(sequence str)
  sequence s
  atom pipe
  integer c

  s = ""
  if platform() = LINUX then
    pipe = popen(str, "r")
    if pipe = 0 then
      error_message("Could not open pipe!", 1)
    end if
    while 1 do
      c = fgetc(pipe)
      puts(1, c)
      if c = -1 then
	    exit
      else
	    s &= {c}
      end if
    end while
    pclose(pipe)
  end if
  return s
end function

------------------------------------------------------------------------------

function split_lines(sequence str)
  sequence result, s

  result = {}
  s = {}
  for i = 1 to length(str) do
    if str[i] = '\n' then
      result = append(result, s)
      s = {}
    else
      s = s & str[i]
    end if
  end for
  result = append(result, s)
  return result
end function

------------------------------------------------------------------------------

function peek_string(atom addr)
  atom ptr

  ptr = addr
  while peek(ptr) do ptr += 1 end while
  return peek({addr, ptr-addr})
end function

------------------------------------------------------------------------------

global function getLnxVersion(sequence FileName)
  sequence s, splitted

  if platform() = LINUX then
    if compare(FileName[$-2..$], "exu") = 0 then
      s = execute_command("/usr/local/euphoria/bin/exu < dummy.ex")
      splitted = split_lines(s)
      return splitted[1][length("Euphoria Interpreter ")+1..$]
    else
      s = execute_command(FileName & " --version")
      splitted = split_lines(s)
      return splitted[1][length("Euphoria Interpreter v")+1..$]
    end if
  else
    return ""
  end if
end function

if platform() = LINUX then
  ptr = allocate(65*6)
  if c_func(uname, {ptr}) >= 0 then
    arch = peek_string(ptr+(65*4))
  end if
  free(ptr)
end if

