include dll.e
include machine.e
include file.e
include misc.e
include wildcard.e
include msgbox.e

global sequence arch
arch = "unknown"

global integer address_length
address_length = 4

global constant
  EU_4_1_LNX_64 = 1, EU_4_1_LNX_32 = 2, EU_4_0_LNX = 3, EU_3_1_LNX = 4,
  EU_4_1_WIN_64 = 5, EU_4_1_WIN_32 = 6, EU_4_0_WIN = 7, EU_3_1_WIN = 8

global integer f_debug
f_debug = 0

global object void
void = 0

------------------------------------------------------------------------------

global procedure log_message(sequence msg)
  if f_debug then
    puts(f_debug, msg)
    flush(f_debug)
  end if
end procedure

------------------------------------------------------------------------------

global procedure error_message(sequence msg, atom quit)
-- logs an error and displays a warning
-- if quit is set then abort
  log_message(msg)
  if platform() = WIN32 then
    void = message_box(msg, "Error", MB_ICONERROR+MB_OK+MB_APPLMODAL+MB_SETFOREGROUND)
  elsif platform() = LINUX then
    puts(2, "Error: " & msg & "\n")
  end if
  if quit then
    abort(1)
  end if
end procedure

------------------------------------------------------------------------------

include win_version.e
include lnx_version.e

global integer eu_version
eu_version = 0

global sequence eu_text_version
eu_text_version = ""

------------------------------------------------------------------------------

global function eu_version_name()
  if eu_version = EU_4_1_LNX_64 then
    return "EU_4_1_LNX_64"
  elsif eu_version = EU_4_1_LNX_32 then
    return "EU_4_1_LNX_32"
  elsif eu_version = EU_4_0_LNX then
    return "EU_4_0_LNX"
  elsif eu_version = EU_3_1_LNX then
    return "EU_3_1_LNX"
  elsif eu_version = EU_4_1_WIN_64 then
    return "EU_4_1_WIN_64"
  elsif eu_version = EU_4_1_WIN_32 then
    return "EU_4_1_WIN_32"
  elsif eu_version = EU_4_0_WIN then
    return "EU_4_0_WIN"
  elsif eu_version = EU_3_1_WIN then
    return "EU_3_1_WIN"
  end if
  return ""
end function

------------------------------------------------------------------------------

sequence cmd, s

cmd = command_line()

if platform() = WIN32 then
  s = getWinVersion(cmd[1])
  eu_text_version = s & " for Windows"
  if compare(s[1..3], "3.1") = 0 then
    eu_version = EU_3_1_WIN
    address_length = 4
  elsif compare(s[1..3], "4.0") = 0 then
    eu_version = EU_4_0_WIN
    address_length = 4
  elsif compare(s[1..3], "4.1") = 0 then
    if compare(arch, "x86") = 0 then
      eu_version = EU_4_1_WIN_32
      address_length = 4
    elsif compare(arch, "AMD64") = 0 then
      eu_version = EU_4_1_WIN_64
      address_length = 8
    end if
  end if
elsif platform() = LINUX then
  s = getLnxVersion(cmd[1])
  if compare(s[1..3], "3.1") = 0 then
    eu_text_version = s
    eu_version = EU_3_1_LNX
    address_length = 4
  elsif compare(s[1..3], "4.0") = 0 then
    eu_text_version = s & " for Linux"
    eu_version = EU_4_0_LNX
    address_length = 4
  elsif compare(s[1..3], "4.1") = 0 then
    eu_text_version = s & " for Linux"
    if compare(arch, "i686") = 0 then
      eu_version = EU_4_1_LNX_32
      address_length = 4
    elsif compare(arch, "x86_64") = 0 then
      eu_version = EU_4_1_LNX_64
      address_length = 8
    end if
  end if
end if
